"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogLevel = exports.getLogger = exports.getLoggerBuilder = void 0;
var ConsoleLogger_1 = require("./ConsoleLogger");
var LoggerBuilder_1 = require("./LoggerBuilder");
/**
 * Build a customized logger instance
 */
function getLoggerBuilder() {
    return new LoggerBuilder_1.LoggerBuilder(ConsoleLogger_1.buildConsoleLogger);
}
exports.getLoggerBuilder = getLoggerBuilder;
/**
 * Get a default logger instance without any configuration
 */
function getLogger() {
    return getLoggerBuilder().build();
}
exports.getLogger = getLogger;
var contracts_1 = require("./contracts");
Object.defineProperty(exports, "LogLevel", { enumerable: true, get: function () { return contracts_1.LogLevel; } });
